USER_PUNCH
# used to generate data for a %species vs pH plot
# 'mainspecies' in the input file is used to set the main species (sets the <mainspecies> tag)
# writes succesive 'species names-value' pairs to the 'out' file
# these are plotted with a custom plot
# the species always starts with the xaxis variable (here pH) then all the other main component
# species in descending abundance order
#
# The input file
# ==============
# '<mainspecies>' must be set to the component of interest
# 'customxcolumn' must be set to the column where the pH is written, here 2
#
-start
 10 main$ = "<mainspecies>"
 20 punch "pH", -la("H+")
 30 totel=SYS("surf",n,n$,t$,c)
 35 totAs = 0
 40 for i=1 to n
 45   ipos = instr(n$(i),main$)
 50   if (ipos>0) then 80 else 90
 80   totAs = totAs + c(i)
 90 next i

140 for i=1 to n
145   ipos = instr(n$(i),main$)
150   if (ipos>0) then 180 else 190
180   punch n$(i),100*c(i)/totAs
190 next i
-end
