# Used by ht1 and grid calculations to calculate a predominance diagram based on the 'predominance' criterion.
# adds the formula of each mineral underneath its phase name in the plot
PRINT
   -reset false
PHASES
Fix_H+
   H+ = H+
   log_k 0.0
SELECTED_OUTPUT 1
   -high_precision true
   -reset false
USER_PUNCH 1
-headings
-start
1 small = 1e-12
20 nout1 = 0
40 nout3 = 0
50 main$ = "<mainspecies>"
60 IF (STEP_NO = 0) THEN 370 ELSE 70
70 totel = SYS(main$, n, n$, t$, moles)
80 h2o = TOT("water")

90 REM Filter out gases
100 FOR i = 1 TO n
110   IF (moles(i) <= small) THEN 190
130   IF (INSTR(n$(i), "(g)") > 0) THEN 180
131   temp$ = PHASE_FORMULA(n$(i))
132   if (temp$<>'') THEN temp$ = n$(i) + "<br>(" + temp$ + ")" ELSE temp$ = n$(i)
140   PUNCH temp$, moles(i)/h2o
150 REM   PRINT i, n$(i), moles(i)/h2o
160   nout1 = nout1 + 1
170   IF(nout1 >= 3) THEN 190
180 NEXT i

190 REM no forced mineral species (see ht1stability.inc)
191 nout2 = 0

200 REM add these constraints or overrides
201 IF (SI("H2(g)") > 0) THEN 210 ELSE 230
210 PUNCH "H2(g) > 1 atm", 10^SI("H2(g)")
220 nout3 = nout3 + 1
230 IF (SI("O2(g)") > -0.677) THEN 240 ELSE 260 # you may prefer 1 atm but if so, use '>1e-12' here, say, so you can set ymax = 0
240 PUNCH "O2(g) > 0.21 atm", 10^SI("O2(g)")
250 nout3 = nout3 + 1
260 IF (SI("CH4(g)") > 0) THEN 270 ELSE 290
270 PUNCH "CH4(g) > 1 atm", 10^SI("CH4(g)")
280 nout3 = nout3 + 1

290 REM No 'carry' variables for viewing
291 nout4 = 0

300 REM the 5 system variables (always required)
301 po2 = SI("O2(g)")
310 ph2 = SI("H2(g)")
320 ph = -LA("H+")
330 pe = -LA("e-")
340 PUNCH "pH", ph, "pe", pe, "PO2", po2, "PH2", ph2, "temp", TC

350 REM output the 5 counters
351 nout5 = 5
360 PUNCH nout1, nout2, nout3, nout4, nout5
370 END

