# As for ht1 but predominance based only on abundance of available redox states
# i.e. all species with the same redox state have been combined together
# Thanks to Rémi Marsac (INE) for the suggestion

PHASES
Fix_H+
   H+ = H+
   log_k 0.0
   
PRINT
   -reset false
   
SELECTED_OUTPUT 1
   -high_precision true
   -reset false
   
USER_PUNCH 1
-headings 
-start
10 IF(STEP_NO = 0) THEN 570
20 minc = 1e-15
30 nout1 = 0
40 nout3 = 0
50 main$ = "<mainspecies>"
60 h2o = TOT("water")
70 IF(STEP_NO = 0) THEN 570 ELSE 90
80 REM
90 n = 17
100 DIM ns(n), ns$(n), indx(n)
110 REM loop through valence states involved, say -8 to +8
120 FOR j = 1 TO n
130   i = ABS(j-9)
190   ns$(j) = main$ + "(" + TRIM(STR$(i)) + ")"
200   ns(j) = SYS(ns$(j), ne, n$, t$, moles)
220   REM PRINT j, ns$(j), ns(j)
230 NEXT j
231 REM
240 REM sort concns
250 GOSUB 30110
260 REM
270 FOR i = n TO 1 STEP -1
280   IF(ns(i) <= minc) THEN 330
290   REM PRINT i, indx(i), ns$(indx(i)), ns(i)/h2o
300   PUNCH ns$(indx(i)), ns(i)/h2o
310   nout1 = nout1+1
320   IF(nout1 >= 3) THEN 350
330 NEXT i
331 REM
340 REM no forced mineral species (see ht1stability.inc)
350 nout2 = 0
360 REM add these constraints or overrides
370 IF(SI("H2(g)") > 0) THEN 380 ELSE 400
380 PUNCH "H2(g) > 1 atm", 10^SI("H2(g)")
390 nout3 = nout3+1
400 IF(SI("O2(g)") > -0.677) THEN 410 ELSE 430
410 PUNCH "O2(g) > 0.21 atm", 10^SI("O2(g)")
420 nout3 = nout3+1
430 IF(SI("CH4(g)") > 0) THEN 440 ELSE 460
440 PUNCH "CH4(g) > 1 atm", 10^SI("CH4(g)")
450 nout3 = nout3+1
460 REM add any extra 'carry' variables for viewing
470 nout4 = 0
480 REM the 5 system variables (always required)
490 po2 = SI("O2(g)")
500 ph2 = SI("H2(g)")
510 ph = -LA("H+")
520 pe = -LA("e-")
530 PUNCH "pH", ph, "pe", pe, "PO2", po2, "PH2", ph2, "temp", TC
540 REM output the 5 counters
550 nout5 = 5
560 PUNCH nout1, nout2, nout3, nout4, nout5
570 END

# SORT ROUTINE
30000 REM insertion sort with index (after Numerical Recipes)
30010 REM input: 
30020 REM   ns() is a numeric array of length n to be sorted
30030 REM   indx() should start with an array of length at least n
30040 REM output:
30050 REM   ns() is sorted
30060 REM   indx() contains sorted sequence        
30070 REM
30090
30100 REM set indices to 1, 2, ... ns
30110 FOR js = 1 TO n
30120    indx(js) = js
30130 NEXT js
30140
30150 IF(n < 2) THEN GOTO 30280
30160 FOR js = 2 TO n
30170    as = ns(js)
30180    bs = indx(js)
30190    FOR is = js-1 TO 1 STEP -1
30200       IF(ns(is) <= as) THEN 30250
30210       ns(is+1) = ns(is)
30220       indx(is+1) = indx(is)
30230    NEXT is
30240    is = 0
30250    ns(is+1) = as
30260    indx(is+1) = bs
30270 NEXT js
30280 RETURN
-end
